package moverCirculo;

import java.awt.BorderLayout;
import java.awt.Dimension;

import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

@SuppressWarnings("serial")
public class MoverCirculo extends JFrame{

	JSlider horizontal;
	JSlider vertical;
	PanelCirculo panelCirculo;

	public MoverCirculo() {

		setLayout(new BorderLayout());
		add(new PanelHorizon(), BorderLayout.SOUTH);
		add(new PanelVerti(), BorderLayout.EAST);
		add(new PanelCentral(), BorderLayout.CENTER);

		setTitle("Mover Círculo");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setResizable(false);
		pack();
		setLocationRelativeTo(null);
		setVisible(true);
	}

	//******Clases panel******
	
	class PanelCentral extends JPanel {
		
		public PanelCentral() {
			panelCirculo = new PanelCirculo();
			setBorder(BorderFactory.createEmptyBorder(20, 20, 20, 20));
			add(panelCirculo);
		}
	}
	class PanelHorizon extends JPanel{

		public PanelHorizon() {
			horizontal = new JSlider();
			horizontal.setMaximum(450);
			horizontal.setValue(250);
			horizontal.setPreferredSize(new Dimension(500, 60));
			horizontal.setMajorTickSpacing(50);
			horizontal.setMinorTickSpacing(5);
			horizontal.setPaintTicks(true);
			horizontal.setPaintLabels(true);
			horizontal.addChangeListener(new MueveEjeX());
			add(horizontal);
		}
	}

	class PanelVerti extends JPanel{

		public PanelVerti() {
			vertical = new JSlider();
			vertical.setOrientation(SwingConstants.VERTICAL);
			vertical.setMaximum(450);
			vertical.setValue(250);
			vertical.setPreferredSize(new Dimension(60, 500));
			vertical.setMajorTickSpacing(50);
			vertical.setMinorTickSpacing(5);
			vertical.setPaintTicks(true);
			vertical.setPaintLabels(true);
			vertical.setInverted(true);
			vertical.addChangeListener(new MueveEjeY());
			add(vertical);
		}
	}
	
	//*****Clases Listener*****
	
	class MueveEjeX implements ChangeListener {
		@Override
		public void stateChanged(ChangeEvent e) {
			if (horizontal.getValueIsAdjusting())
				panelCirculo.desplazarX(horizontal.getValue());
			
		}
	}
	
	class MueveEjeY implements ChangeListener {
		@Override
		public void stateChanged(ChangeEvent e) {
			if (vertical.getValueIsAdjusting())
				panelCirculo.desplazarY(vertical.getValue());
			
		}
	}

	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {
			@Override
			public void run() {
				new MoverCirculo();	
			}
		});
	}

}
